# SinqEPICSApp

This is an IOC application which contains the drivers for SINQ hardware. 
EPICS purists may find it messy because it contains the drivers for all 
SINQ stuff in one package rather then in separate modules. This is just 
for ease of distribution. The idea being that all of SINQ shares one 
module/IOC application and configures in its startup file what it needs 
of it.  

Drivers included:

- EL734 motor controller
- SINQ Delta Tau PMAC motor controller. This is a modified version of the Diamond 
  PMAC code. The modification is necessary because PSI runs a different program in 
  the MCU at SINQ then Diamond
- Nanotec bus motor driver
- Phytron MCU200 motor driver
- EL737 counter box driver through the scaler record

There are some streamdevice protocol files provided:
- spss5: for the Siemens SPS5 with the PSI custom RS232 module
- slsvme: for the SLS magnet controllers managed by the SINQ special vmemaggi program
- el755: the old SINQ magnet controller
- dimetix: for the deimetix distance measurement device at AMOR

There are two main branches here:

- Of course master from which you can build the PSI RHEL7 module and the EEE module
- The amorsim branch in which you can build the IOC application for ESS against the ICS 
  setup. This is needed for the sinq-amorsim simulation.  This branch exists because of the 
  political problem to get a module into the ICS EEE setup.

Those political problems require a special development model:

1. If you do something, do it in a separate branch
2. When reasonably sure that what you did works, merge it both into master and amorsim

Take care of the sinqEPICsApp/src/sinq.dbd file. This is the one which differs mostly between 
amorsim and master branches. 

# Formatting

Formatting is done via the [`.clang-format`](./.clang-format) file checked into
the repository. One option to apply the formatting to a given file is via the
command below.

```
clang-format -i -style=file <file>
```
