/*
  This class contains the necessary changes to have an additional text fields for messages 
  with each axis. 

  Code lifted from Torsten Boegershausens ESS code.

  Mark Koennecke, March 2017
*/

#ifndef __SINQCONTROLLER
#define __SINQCONTROLLER
#include "asynMotorController.h"

#define motorMessageIsFromDriverString  "MOTOR_MESSAGE_DRIVER"
#define motorMessageTextString          "MOTOR_MESSAGE_TEXT"

class epicsShareClass SINQController : public asynMotorController
{
 public:
  SINQController(const char *portName, const char *SINQPortName, int numAxes, const int& extraParams=2);
  asynStatus setInterMessageSleep(int messageSleep);
 
  friend class SINQAxis;
 protected:
  int motorMessageIsFromDriver_;
  int motorMessageText_;

  int interMessageSleep; // minimum time between message to the controller in microseconds
                         // for slowing down communication to weak controllers.....
}; 


#endif
 
